**Free
// LUCase_Ex2
// ----------
// Example program for use of LCase() and UCase() functions.
//
// Jesper Wachs, July 2018.
//   Converted to Totally Free RPG.
//
// Jesper Wachs, May 2018.
//
// The source member are delivered 'as is'.
//
// Neither Jesper Wachs nor anyone else who has been involved in
// the creation, production or delivery of this product shall be
// liable for any direct, indirect, consequential or incidental
// damages (including damages for loss of business profits,
// business interruption, loss of business information, and the
// like) arising out of the use or inability to use such product
// even if Jesper Wachs has been advised of the possibility of
// such damages.
//
// Copymember for imported functions.
// ----------------------------------
/copy qrpglesrc,lucase_pr

//
// Prototypes for local functions.
// -------------------------------
Dcl-PR Convert VarChar(1024);
  iString VarChar(1024) Const;
  iUpLow Packed(1:0) Const;
End-PR;

Dcl-PR OldUCase VarChar(1024);
  iString VarChar(1024) Const;
End-PR;

//
// Work fields.
// ------------
Dcl-S Limit Int(10:0) Inz(10000);
Dcl-S Count Int(10:0);
Dcl-S LowStr Char(20) Inz('Some string');
Dcl-S UpStr Char(20);
Dcl-S StartTime TimeStamp;
Dcl-S EndTime TimeStamp;
Dcl-S Interval Int(10:0);
Dcl-S Message Char(25);

//
// RPG Xlate with national support.
//
//  Round 1: The API 'QlgConvertCase' is only called the first time
//           to fill two helper strings that is then used with XLate.
//
StartTime = %TimeStamp();

For Count = 1 to Limit;
  UpStr = UCase(LowStr);
EndFor;

EndTime = %TimeStamp();
Interval = %diff(EndTime: StartTime: *MS);

Message = %Char(Interval) +
  ' microsec Xlate';

Dsply Message;
//
//  Round 2: My old 'UCase' procedure is called. It will call the API
//           'QlgConvertCase' each time to convert the string.
//
StartTime = %TimeStamp();

For Count = 1 to Limit;
  UpStr = OldUCase(LowStr);
EndFor;

EndTime = %TimeStamp();
Interval = %diff(EndTime: StartTime: *MS);
 
Message = %Char(Interval) +
  ' microsec Xlate2';

Dsply Message;
//
// SQL Upper
//
StartTime = %TimeStamp();

For Count = 1 to Limit;
  Exec SQL
    Set :UpStr = Upper(:LowStr);
EndFor;

EndTime = %TimeStamp();
Interval = %diff(EndTime: StartTime: *MS);

Message = %Char(Interval) +
  ' microsec SQL';

Dsply Message;

// End

Message = 'Press ENTER';

Dsply Message;

*InLR = *On;
Return;
//
// Convert
// -------
// Internal function that handles call to API for conversion.
//
Dcl-Proc Convert;
Dcl-PI Convert VarChar(1024);
  iString VarChar(1024) Const;
  iUpLow Packed(1:0) Const;
End-PI;

Dcl-PR QlgCvtCase ExtProc('QlgConvertCase');
  CtrlBlock Const LikeDS(FRCB);
  inString Char(32767) Const Options(*VARSIZE);
  OutString Char(32767) Options(*VARSIZE);
  nLength Int(10:0) Const;
  apiError Char(16);
End-PR;

Dcl-S oString Char(32767);
Dcl-S APIErrorDS Char(16) Inz(*AllX'00');

Dcl-DS FRCB Qualified;
  ReqType Int(10:0);
  CCSID Int(10:0) Inz(0);
  CvtTo Int(10:0);
  Reserved Char(10) Inz(*ALLX'00');
End-DS;

Dcl-DS CtrlBlock LikeDS(FRCB);

  CtrlBlock = *Allx'00';
  APIErrorDS = *AllX'00';
  CtrlBlock.ReqType = 1;
  CtrlBlock.CvtTo = iUpLow;

  CallP QlgCvtCase(CtrlBlock):
                   iString:
                   oString:
                   %Len(iString):
                   APIErrorDS);

  Return %SubSt(oString: 1: %Len(iString));

End-Proc Convert;
//
// OldUCase
// --------
// Convert a string to uppercase taking national characters into
// account.
//
Dcl-Proc OldUCase;
Dcl-PI OldUCase VarChar(1024);
  IString VarChar(1024) Const;
End-PI;

  Return Convert(iString: 0);

End-Proc OldUCase;
